%This script tests the routine  HBW-BSPMP2D 
%The signal is the Head1 X-ray image (to change it change 'ImagePath' below)
%By default the partition is of length NbxNb=8x8 (to change it change 'Nb' below)
%The final approximation is up to SNR=48.1dB after downgrading, to change it change 'pssb' below)
%The approximation before downgrading is up to SNR=49dB,  to change it change 'pss' below)
%The dictionary is a mixed dictionary. To change the dictionary input Dx and Dy
%
%By default this script uses  C++ Mex version  of  OMP2D  for the forward selection, to run the Matlab version  comment line 78  and uncomment line 77
%To run SPMP2D uncomment line 20 (or 21 for MP2D). To run the  matlab version of  SPMP2D version  uncomment 80 and comment line 81
%
%
ImagePath='lukas_2d_8_hand_1_t.tif'
%
Nb=8; %change to change block size
method='OMP2D' %comment to run SPMP2D 
pss =42.2;
pssb =48.5;
%
%-------uncomment line 20 for SPMP2D or 21 for MP2D---------------------
%lstep=1; method='SPMP2D'
%lstep=-1;method='MP2D'
%-----------------------------------------------------------------------
% 
[mImage, sInfo, map] = LoadImage(ImagePath); %load the image 
[mI, bitDepth] = MImage2Grey(mImage, sInfo, map);%convert it to Grey
%
clear  Di1 Di2 Q c cmIa 
%
bw=Nb;
blockWidth=bw
%
get_mix_dict %input the dictionary mixed dictioanries Dx and Dy

s=floor(size(mI)/bw)

mI=mI(1:s(1)*bw,1:s(2)*bw); %rezise the images to be divisible by bw
mI2=mI;  %keep the pixel image
wlevel=5;

mI= waveletcdf97(mI2, wlevel);  %transform to wavelet domain

MaxInt=max(max(mI2));
MaxIntb=255;

dz=zeros(bw,1);

[cmI, nYBlocks, nXBlocks] = BlockImage(mI, blockWidth); %for blocking (James)

[Lx,Ly]=size(cmI{1,1});
delta=1/(Lx*Ly);
NBY=nYBlocks;
NBX=nXBlocks;

cmIa= cell(nYBlocks,nXBlocks);
No=[];
tol=MaxIntb^2/(10^(pss/10))
tol2=sqrt(tol*(Lx*Ly))
toln=1e-8;
toln2=sqrt(toln*Lx*Ly);
nCoe=0;
darkb=0;
%---------------for SPMP2D----------------
Max=150000; %Maximum numer of iterations this is blockwith dependent!!!
Maxp=150000;%blockwith dependent!!!
indx=[];
indy=[];
%---------------------------------------------------
tic
clear c cbeta Di2 Di1 h 
q=0;
for i = 1:nYBlocks
for j = 1:nXBlocks
q=q+1;
B=cmI{i,j};
 if sum(sum(B).^2)*delta>1e-15 %if the intensity of the whole plock is zero use the zeor block
if strcmp(method,'OMP2D')
%[h,Di1{q},Di2{q},cbeta{q},c{q},Q]=OMP2D_m(B,Dx,Dy,tol,No);
[h,Di1{q},Di2{q},cbeta,c{q},Q,vin]=OMP2D_Mex(B,Dx,Dy,tol2^2,No,indx,indy);
else
%[h,Di1{q},Di2{q},c{q}]=SPMP2D(B,Dx,Dy,tol,No,toln2,lstep,Max,Maxp,indx,indy);
[h,Di1{q},Di2{q},c{q}]=SPMP2D_Mex(B,Dx,Dy,tol2,No,toln2,lstep,Max,Maxp,indx,indy);
end
cmIa{i,j}=h;
nCoe =nCoe + numel(c{q});
 else
cmIa{i,j}=dz*dz'; %zero block (dark ernegy)
nCoe = nCoe + 1;
darkb=darkb+1;
c{q}=[];
 end
end
end
nCoe2=nCoe-darkb
toc
clear mImage
mIc=cell2mat(cmIa);%get the images from the flocks
mImage=waveletcdf97(mIc,-wlevel);%get back to the pixes domain
fprintf('number of dark blocks.\n') 
darkb
clear ssim_ind
MSSIM=ssim(mI2, mImage)
PSNR=CalcPSNR2(mI2,mImage,MaxIntb) % PSNR of the approximation
SR= numel(mI2)/nCoe2 % Sparsity ratio

tolb=MaxIntb^2/(10^(pssb/10));
tol4=tolb*numel(mI2)
No=floor(nCoe/10);%  sloppy to stop by tol4, to stop by numeber of terrms change the value of No 

toln=1e-8;
toln2=sqrt(toln*Lx*Ly);
[cmIb,cDi1,cDi2,cb,Natb]=HBW_BSPMP2D(cmI,cmIa,Dx,Dy,Di1,Di2,c,tol4,No,toln2,Max);
toc

mIb=cell2mat(cmIb);
mImageb=waveletcdf97(mIb,-wlevel);%get back to the pixes domain

fprintf('HBW-BSPMP2D results')
SRb=numel(mI2)/Natb
PSNRb=CalcPSNR2(mI2,mImageb,MaxIntb) 

MSSIM=ssim(mI2, mImageb)

return

