%This script tests the HBW-OMP2D routine
%The signal is the Hand1 X-ray image (to change it change 'ImagePath' 12 below)
%By default the partition is of length NbxNb=8x8 (to change it change 'Nb' below)
%The  approximation is up to SNR=48.1dB,  to change it change 'pss' below)
%The dictionary is a mixed dictionary, to change the dictionary input Dx and Dy. 
%---------------------------------------------------------------------------------------------------------
%By default the  Mex file for HBW-OMP2D is used. To use the  Matlab  version uncomment line 60 and comment line 61
%---------------------------------------------------------------------------------------------------------
%
ImagePath='lukas_2d_8_hand_1_t.tif'
%ImagePath='lukas_2d_8_foot_0_t.tif'

[mImage, sInfo, map] = LoadImage(ImagePath); %load the image 
[mI, bitDepth]= MImage2Grey(mImage, sInfo, map);%convert it to Grey 
%
Nb=8 %block size 
pss2=48.5 %chenge this to adjust a different PSNR
bw=Nb;
blockWidth=Nb;
%
get_mix_dict %input the dictionary mixed dictioanries Dx and Dy
%
s=floor(size(mI)/bw);
%
mI=mI(1:s(1)*bw,1:s(2)*bw);%resize the images to be divisible by bw
mI2=mI; %keep the pixel image
wlevel=5;
mI= waveletcdf97(mI2, wlevel);%transform to wavelet domain
%
MaxInt=max(max(mI2));
MaxIntw=max(max(mI));
MaxIntb=255;
%
[Nx,Ny]=size(mI2);
%
dz=zeros(bw,1);
%
[cmI, nXBlocks, nYBlocks] = BlockImage(mI, blockWidth); %for blocking 
%
NBX=nXBlocks
NBY=nYBlocks
%
[Lx,Ly]=size(cmI{1,1});
delta=1/(Lx*Ly);


cmIa= cell(nXBlocks,nYBlocks);
%
tol=MaxInt^2/(10^(pss2/10))% tolerance error
tol3=(tol*(Nx*Ny))%tolerance normatized error (mse)
%
%
B=cmI; %cell array with all the blocks
No=numel(mI);%to stop by achieved the PSNR set by 'pss' above
Max=50000;
Maxp=50000;
%
clear c Di1 Di2 beta c Q hbw
tic
%[hbw,Di1,Di2,beta,c,Q,Nat]=HBW_OMP2D(B,Dx,Dy,tol3,No);
[hbw,Di1,Di2,beta,c,Q,Nat]=HBW_OMP2D_Mex(B,Dx,Dy,tol3,No);
toc
%=====================================================================
clear mImage
mIc=cell2mat(hbw);%get the images from the flocks
mImage=waveletcdf97(mIc,-wlevel);%get back to the pixes domain
PSNR=CalcPSNR2(mI2,mImage,MaxIntb) % PSNR of the approximation
SR= numel(mI2)/Nat% Sparsity ratio
Nat %numer of atoms
fprintf('Method HBW-OMP2D \n');
%imshow(uint8(mImage))
clear ssim_ind
MSSIM=ssim(mI2, mImage) %
return

