%This script tests the routines OHBW-OMP2D, HBW-SPMP2D or HBW-MP2D.
%The signal is the Hand_1 X-ray image (to change it change 'ImagePath' below)
%By default the partition is of length NbxNb=8x8 (to change it change 'Nb' below)
%The  approximation is up to SNR=48.1dB,  to change it change pss2 below
%The dictionary is a mixed dictionary. To change the dictionary input Dx and Dy. 
%
%By default the script runs the C++ Mex version of HBW-OMP2D to run the Matlab version 
%comment line 72  and uncomment line 73.
%To test HBW-SPMP2D comment line 15 and uncomment line 19
%To test HBW-MP2D comment line 15 and uncomment line 20.

ImagePath='lukas_2d_8_hand_1_t.tif'
%
Nb=8 %change to change block size
method='OHBW-OMP2D' %comment to run HBW-SPMP2D or HBW-MP2D
pss2=48.5; %comment to run HBW-SPMP2D or HBW-MP2D
%
%---------------uncomment for HBW-SPMP2D or HBW-MP2D------------------------
%method='HBW-SPMP2D'
%method='HBW-MP2D'
%---------------------------------------------------------------------------
%
[mImage, sInfo, map] = LoadImage(ImagePath); %load the image 
[mI, bitDepth]= MImage2Grey(mImage, sInfo, map);%convert it to Grey 
%
%
bw=Nb;
blockWidth=Nb;
%==================input the mixed dictionary- to change it input Dx Dy====
get_mix_dict % call the script which generates Dx Dy
%==========================================================================
s=floor(size(mI)/bw);
%
mI=mI(1:s(1)*bw,1:s(2)*bw);%resize the images to be divisible by bw
mI2=mI; %keep the pixel image
wlevel=5;
mI= waveletcdf97(mI2, wlevel);%transform to wavelet domain
%
MaxInt=max(max(mI2));
MaxIntw=max(max(mI));
MaxIntb=255;
%
[Nx,Ny]=size(mI2);


dz=zeros(bw,1);

[cmI, nXBlocks, nYBlocks] = BlockImage(mI, blockWidth); %for blocking 

NBX=nXBlocks
NBY=nYBlocks

[Lx,Ly]=size(cmI{1,1});
delta=1/(Lx*Ly);


cmIa= cell(nXBlocks,nYBlocks);
%
tol=MaxInt^2/(10^(pss2/10))% tolerance error
tol3=(tol*(Nx*Ny))%tolerance normatized error (mse)
%
%
B=cmI; %cell array with all the blocks
No=numel(mI);%to stop by achieved PSNR set by (pss2)
Max=50000;
Maxp=50000;
toln=1e-8;
toln2=sqrt(toln*Lx*Ly);
%
tic
if strcmp(method,'OHBW-OMP2D')
%[h,Di1,Di2,beta,c,Q,Nat]=OHBW_OMP2D(B,Dx,Dy,tol3,No);
[h,Di1,Di2,beta,c,Q,Nat]=HBW_OMP2D_Mex(B,Dx,Dy,tol3,No);
else
if strcmp(method,'HBW-MP2D'); 
 [h,Di1,Di2,c,Nat]=HBW_MP2D(B,Dx,Dy,tol3,No);
end
if strcmp(method,'HBW-SPMP2D');
[h,Di1,Di2,c,Nat]=HBW_SPMP2D(B,Dx,Dy,tol3,No,toln2,Max,Maxp);
end
end
%
toc
%=====================================================================
clear mImage
mIc=cell2mat(h);%get the images from the flocks
mImage=waveletcdf97(mIc,-wlevel);%get back to the pixes domain
PSNR=CalcPSNR2(mI2,mImage,MaxIntb) % PSNR of the approximation
SR= numel(mI2)/Nat% Sparsity ratio
Numeber_of_Atoms=Nat %numer of atoms
MSSIM=ssim(mI2, mImage)
return

