%This script tests the  OMP2D or SPMP2D routines
%The signal is the Hand_1 X-ray image (to change it change 'ImagePath' below)
%By default the partition is of length NbxNb=8x8 (to change it change 'Nb' below)
%The  approximation is up to SNR=48.1dB,  to change it change 'pss' below)
%The dictionary is a mixed dictionary. To change the dictionary input Dx and Dy
%
%By default this script runs the  C++ Mex of OMP2D to use the Matlab verison   uncomment line 78  and comment line 79
%To test SPMP2D uncomment line 19 (or 20 for MP2D). To run  the Matlab veriosn uncomment line 81  and comment line 82
%
%
ImagePath='lukas_2d_8_hand_1_t.tif'
%
%
Nb=8 %change to change block size
method='OMP2D' %comment to run HBW-SPMP2D or HBW-MP2D
pss=40.5; %
%
%-------uncomment line 19 for SPMP2D or line 20 for MP2D--------------------
%lstep=1; method='SPMP2D'
%lstep=-1;method='MP2D'
%---------------------------------------------------------------------------
% 
[mImage, sInfo, map] = LoadImage(ImagePath); %load the image 
[mI, bitDepth] = MImage2Grey(mImage, sInfo, map);%convert it to Grey
%
bw=Nb
blockWidth=bw
%
clear  Di1 Di2 Q c cbeta h
%===input the mixed dictionary- to change it input Dx Dy.===
get_mix_dict
%===========================================================


s=floor(size(mI)/bw)

mI=mI(1:s(1)*bw,1:s(2)*bw); %rezise the images to be divisible by bw
mI2=mI;  %keep the pixel image
wlevel=5;

mI= waveletcdf97(mI2, wlevel);  %transform to wavelet domain

MaxInt=max(max(mI2));
MaxIntb=255;

dz=zeros(bw,1);

tic
[cmI, nYBlocks, nXBlocks] = BlockImage(mI, blockWidth); %for blocking 

[Lx,Ly]=size(cmI{1,1});
delta=1/(Lx*Ly);
NBY=nYBlocks;
NBX=nXBlocks;

cmIa= cell(nYBlocks,nXBlocks);
No=[];
tol=MaxIntb^2/(10^(pss/10))
toln=5e-4;
tol2=sqrt(tol*(Lx*Ly))
toln2=sqrt(toln*Lx*Ly);
nCoe=0;
darkb=0;
%---------------for SPMP2D----------------
Max=150000; %Maximum numer of iterations this is blockwith dependent!
Maxp=150000;
indx=[];
indy=[];
fixat=0;
%---------------------------------------------------
q=0;
for i = 1:nYBlocks
for j = 1:nXBlocks
q=q+1;
B=cmI{i,j};
 if sum(sum(B).^2)*delta>1e-5 %if the intensity of the whole plock is zero use the zeor block
if strcmp(method,'OMP2D')
%[h,Di1{q},Di2{q},cbeta{q},c{q},Q]=OMP2D_m(B,Dx,Dy,tol,No);
[h,Di1{q},Di2{q},cbeta,c{q},Q,vin]=OMP2D_Mex(B,Dx,Dy,tol2^2,No,indx,indy);
else
%[h,Di1{q},Di2{q},c{q}]=SPMP2D_new(B,Dx,Dy,tol,No,toln,lstep,Max,Maxp,indx,indy);
[h,Di1{q},Di2{q},c{q}]=SPMP2D_Mex(B,Dx,Dy,tol2,No,toln2,lstep,Max,Maxp,indx,indy);
end
if c{q}==0 darkb=darkb+1; end
cmIa{i,j}=h ; % h is the appoximation of the block
nCoe = nCoe + numel(c{q}); %count the total coefficients
else
    cmIa{i,j}=dz*dz'; %zero block (dark ernegy)
    nCoe = nCoe + 1;
    darkb=darkb+1;
    c{q}=0;
end
end
end 
nCoe2=nCoe-darkb
toc
clear mImage
mIc=cell2mat(cmIa);%get the images from the flocks
mImage=waveletcdf97(mIc,-wlevel);%get back to the pixes domain
PSNR=CalcPSNR2(mI2,mImage,MaxIntb) % PSNR of the approximation
SR= numel(mI2)/nCoe2 % Sparsity ratio
fprintf('number of dark blocks.\n') 
darkb
clear ssim_ind
MSSIM=ssim(mI2, mImage)
