#ifndef GET_INPUT_H
#define GET_INPUT_H

/* Header for populating and validating specific structures from mxArrays */

#include "mex.h"
#include "my_types.h"

/* Get data */
double *Get1DSignal(const mxArray *prhs,ulng &nRows);
double *Get3DImage(const mxArray *prhs,ulng &nRows,ulng &nColumns,ulng &nColours);
double *GetVWeights(const mxArray *prhs, ulng nColours);
double *GetDict(const mxArray *prhs,ulng nRowsToCheck,ulng &nAtoms);
double *GetVIndDictRow(const mxArray *prhs,ulng nIndColumn);
double *GetVIndDictColumn(const mxArray *prhs,ulng nAtoms,ulng &nInd);

/* Validate */
ulng ValidateVIndDictC(ulng nAtoms,ulng nRows,ulng nColumns);
void ValidateVIndDictR(ulng nIndColumn,ulng nRows,ulng nColumns);
void ValidateDict(ulng nRowsToCheck, ulng nRows);
void ValidateVWeights(ulng nColours, ulng nRows, ulng nColumns);

//#include "get_input.cpp"


#endif