#ifndef GET_MATLAB_H
#define GET_MATLAB_H

/* Header for functions that get and validate input from MATLAB mxArrays */

#include "my_types.h"
#include "mex.h"

/* Get data */
ulng GetUlng(const mxArray *prhs);    
lng GetLng(const mxArray *prhs);
double GetDouble(const mxArray *prhs);    
double *Get2DVar(const mxArray *prhs,ulng &M,ulng &N,const char *varName);
double *Get3DVar(const mxArray *prhs,ulng &M,ulng &N,ulng &Z,const char *varName);

/* Validate */
void ValidateScalar(ulng nRows, ulng nColumns);
ulng ValidateVector(ulng n, ulng m);

//#include "get_matlab.cpp"


#endif