#ifndef MATRIX_OPERATIONS_H
#define MATRIX_OPERATIONS_H

#include "my_types.h"

namespace Matrix
{
	void VOuter(dbl *matrix, dbl *v1, dbl *v2, ulng m,
			ulng n, dbl alpha = 1);

	void VOuterG(dbl *matrix, dbl *v1, dbl *v2, ulng m,
			ulng n,dbl alpha = 1);

	void MVMult(dbl *m1, dbl *v1, dbl *returnVector, 
        ulng m, ulng n, ulng nRowsReturn, char chn, dbl alpha = 1);

	void MVMultG(dbl *m1, dbl *v1, dbl *returnVector, 
        ulng m, ulng n, dbl alpha, dbl beta, char chn);

	void MMMult( double *m1, double *m2, double *mReturn, ulng m, ulng n, ulng k,
        ulng nRowsReturn,char chn1, char chn2,dbl alpha = 1);

	void MMMultG( double *m1, double *m2, double *mReturn, ulng m, 
		ulng n, ulng k, dbl alpha, dbl beta, char chn1, char chn2);

	void Scale(dbl *v1, dbl alpha, ulng szVector);

	void VAdd(dbl *v1, dbl *v2, dbl alpha, ulng szVector, 
        ulng incx = 1, ulng incy = 1);

	dbl VNorm(dbl *atom, ulng szSignal, ulng incx = 1);

	dbl VNormalize(dbl *atom, ulng nRows);

	dbl RealInnerProduct(dbl *v1, dbl *v2, ulng szVector, 
        ulng incx = 1, ulng incy = 1);

	void VABS(double *v,ulng nElements);

	ulng VMaxUInt(unsigned int *v, ulng m);

	ulng MaxAbs(double *v, ulng m);

}

void CopyDbl(dbl *array1, dbl *array2, ulng nElements);

void CopyUint8(uchar *array1, uchar *array2, ulng nElements);

void CopyUint16(ushort *array1, ushort *array2, ulng nElements);

void CopyUint32(uint *array1, uint *array2, ulng nElements);

void ZeroFillDbl(dbl *v, ulng n);

#endif