/* 
 * MATLAB Code
 * 
 * setting defauls
 *  [Lx,Nx]=size(Vx);
 *  [Ly,Ny]=size(Vy);
 *  delta=1/(Lx*Ly);
 *  Nxy=Lx*Ly;
 *
 *  if (nargin<12) | (isempty(indy)==1)  
 *      indy=[];
 *  end
 *  if (nargin<11) | (isempty(indx)==1)  
 *      indx=[];
 *  end
 *  if (nargin<10) | (isempty(Maxp)==1)  
 *      Maxp=7000;
 *  end
 *  if (nargin<9)  | (isempty(Max)==1)   
 *      Max=7000;
 *  end
 *  if (nargin<8)  | (isempty(lstep)==1) 
 *      lstep=0;
 *  end
 *  if (nargin<7)  | (isempty(toln)==1) 
 *      tolnu=1e-3;
 *  end
 *  if (nargin<5)  | (isempty(No)==1)   
 *      No=Nxy;
 *  end
 *  if (nargin<4)  | (isempty(tol)==1)   
 *      tol=5e-4*sum(sum(abs(f).^2))*delta;
 *  end
 *  %
 *  name='SPMP2D';
 *  cp=zeros(Nx,Ny);
 *  cc=zeros(Nx,Ny);
 *  MaxInt=max(max(f));
 *
 * NOT NECESSARY - RETURNED FROM A FUNCTION
 * ----------------------------------------
 *  Di1=[];
 *  Di2=[];
 * ----------------------------------------
 *
 *  Dix=1:Nx;
 *  Diy=1:Ny;
 *  numat=0;
 *  numind=numel(indx);
 *  h=0;
 *  Re=f;
 *  tol2=1e-9;
 *  imp=0;
 *  if (lstep == -1) 
 *      imp=1; 
 *  end
 *  if (imp==1) 
 *      lstep=0;
 *  end
 *  if (lstep == 0) 
 *      Maxit2=1; 
 *      lstep=Max;
 *  else 
 *      Maxit2=Max/lstep; 
 *  end
 *  for it=1:Maxit2
 *      for s=1:lstep
 *          if (numat+1)<=numind
 *              [testx,qx]=ismember(indx(numat+1),Dix);
 *              [testy,qy]=ismember(indy(numat+1),Diy);
 *              if testx ~=1  
 *                  error('Demanded index (x) %d is out of dictionary',indx(numat+1));
 *              end
 *              if testy ~=1  
 *                  error('Demanded index (y) %d is out of dictionary',indy(numat+1));
 *              end
 *              q(1)=indx(numat+1);
 *              q(2)=indy(numat+1);
 *              cc(q(1),q(2))=Vx(:,q(1))'*Re*Vy(:,q(2));
 *          else 
 *              cc=(Vx'*Re*Vy);
 *              [c1,c2]=max(abs(cc)); 
 *              [max_c,b2]=max(c1); %selects the atom
 *              q=[c2(b2) b2]; %indices of the 1D selected atoms in each direction
 *              if max_c < tol2 
 *                  fprintf('%s stopped, max(|<f,D>|)<= tol2=%g.\n',name,tol2); 
 *                  break; 
 *              end 
 *          end 
 *          indq1q2=0;
 *          [testq1,indq1]=ismember(q(1),Di1);  
 *          if (testq1 ==1 & q(2)==Di2(indq1)) 
 *              indq1q2=1; 
 *          end
 *          if indq1q2==0
 *              Di1=[Di1 q(1)];
 *              Di2=[Di2 q(2)];
 *              numat=numat+1; %counts the number of distinct atoms
 *          end
 *          cscra=cc(q(1),q(2)); 
 *          cp(q(1),q(2))=cp(q(1),q(2))+cscra;
 *          h_new=Vx(:,q(1))*cscra*Vy(:,(q(2)))';
 *			h = h + h_new;
 *          Re=Re-h_new;%computes the new residual
 *          nor_new=sum(sum(abs(Re).^2))*delta; 
 *          if (numat>=No | (nor_new < tol)) 
 *              break;
 *          end
 *      end 
 *      l=numel(Di1);
 *      for n=1:l
 *          c(n)=cp(Di1(n),Di2(n));
 *      end
 *      %=================================================================  
 *      if imp ~= 1  %if imp=1 pure MP
 *          %======================main modifiction to MP======================
 *          % call ProjMP2D to project Re via MP using dictionaries D1 and D2
 *          %==================================================================
 *          [h,c,Re]=ProjMP2D_mex(Re,h,Vx(:,Di1),Vy(:,Di2),c,toln,Maxp);
 *          for n=1:l
 *              cp(Di1(n),Di2(n))=c(n);
 *          end
 *      % end CHANGED
 *          nor_new=sqrt(sum(sum(abs(Re).^2)));
 *      end
 *
 *      if (numat>=No | (nor_new < tol)) 
 *          break;
 *      end
 *  end
 *  if (lstep ~=Max) & (it==Maxit2) 
 *      fprintf('%s Maximum number of iterations has been reached\n',name);
 *  end
 */
#ifndef SPMP2D_H
#define SPMP2D_H

#ifndef output
#define output 0
#endif

#ifndef linux
#define linux 0
#endif

#define msg mexPrintf

typedef unsigned long int ulong;

#include "../../Common/PursuitFunctions.h"
#include "../../Common/MatrixOperations.h"
#include "ProjMP2D.cpp"

void SPMP2D(
        double *mImage,
        double *mDictColumns,
        double *mDictRows,
        double tolApprox,
        ulong maxNAtoms,
        double tolProjection,
        long lStep, 
        ulong maxIter,
        ulong maxIterProj,
        double *vIndDictColumns,
        double *vIndDictRows,
        double *mApprox,
        double *vIColumnAtoms,
        double *vIRowAtoms,
        double *vCoefficients,
        ulong &nChosen,
        ulong nInitialIndexes,
        ulong nRows,
        ulong nColumns,
        ulong nAtomsColumn,
        ulong nAtomsRow,
        ulong &projMPIter)
{

    /* MATLAB
     *  Nxy=Lx*Ly;
     */
    ulong nPixels = nRows*nColumns;

	/* Extra validation */
	ulong nPossibleAtoms = min(nPixels,nAtomsColumn*nAtomsRow);
	if (maxNAtoms< 0  || maxNAtoms > nPossibleAtoms)
    {

        msg("The minimum number of atoms %i must be greater than 0 and less than %i!\n",maxNAtoms,nPossibleAtoms);
		mexErrMsgTxt("Error!");
    }else if (maxNAtoms != 0)
    {          
        maxNAtoms = min(nPossibleAtoms, maxNAtoms);
    }
            
    /* Assign the original image to the residule
     * MATLAB
     *  Re=f;
     */
    double *mResidule = new double[nPixels];
    CopyElements(mImage,mResidule,nPixels); 
    
    /* Miniumum abs of chosen MP coefficient
     * MATLAB
     *  tol2=1e-9;
     */
    double tolCoefficient = 1e-9;
    
    /* Perform MP or SPMP
     * lstep == -1 is a flag for MP.
     *  Pure MP is the same as SPMP without the projection, therefore lstep
     * must be set back to 1 in this case.
     *  MATLTB
     *  imp=0;
     *  if (lstep == -1) 
     *      imp=1; 
     *  end
     *  if (imp==1) 
     *      lstep=0;
     *  end
     *  if (lstep == 0) 
     *      Maxit2=1; 
     *      lstep=Max;
     *  else 
     *      Maxit2=Max/lstep; ?? floor
     *  end
     * CHANGED
     *  switch lstep
     *  if (lstep == -1) % Pure MP
     *      Maxit2 = 1;
     *      nIterMP = Max;
     *      projMP2D = 0;
     *  elseif lstep = 0 % MP with one projection to improve approx
     *      Maxit2 = 1;
     *      nIterMP = Max;
     *      projMP2D = 1;
     *  elseif lstep >=1 % MP with projection following each lstep iterations
     *      Maxit2 = Max/lstep;
     *      nIterMP = lstep;
     *      projMP2D = 1;
     *  end
     */
    ulong maxIterOutside = 0;
    ulong maxIterMP = 0;
    bool projMP2D = 0;
    if (lStep == -1) // Pure MP
    {
        /* Perform maxIter of MP  with no projection */
        maxIterMP = maxIter;
        maxIterOutside = 1;
        projMP2D = 0;
    }else if(lStep == 0)
    {
        /* Perform maxIter of MP with one projection to improve approx */
        maxIterMP = maxIter;
        maxIterOutside = 1;
        projMP2D = 1;
    }else if(lStep >=1)
    {
        /* Perform MP with projection following each maxIterMP iterations,
         * converges to OMP if maxIterMP == 1
         */
        maxIterMP = lStep;
        maxIterOutside = maxIter/maxIterMP;
        projMP2D = 1;
    }

    /* Don't assumse nChosen or is passed as zero */
    nChosen = 0;    
    
    /* If initial indexes are supplied check they are within the
     * dictionaries supplied.
     * MATLAB
     *  if (numat+1)<=numind
     *      [testx,qx]=ismember(indx(numat+1),Dix);
     *      [testy,qy]=ismember(indy(numat+1),Diy);
     *  end
     *  if testx ~=1  
     *      error('Demanded index (x) %d is out of dictionary',indx(numat+1));
     *  end
     *  if testy ~=1  
     *      error('Demanded index (y) %d is out of dictionary',indy(numat+1));
     *  end
     * Equivelent to check that the entire index arrays are greater than 0
     * and less than nAtoms.
     */
    if(nInitialIndexes != 0)
    {
        // ValidateIndex throws error
        ValidateIndex(vIndDictColumns, nAtomsColumn, nInitialIndexes);
        ValidateIndex(vIndDictRows, nAtomsRow, nInitialIndexes);        
    }
    
    
    /* Initialize coefficient helper matrix
     *  The chosen coefficients are stored in a vector which may need to be 
     * updated frequently.
     *  The position of these coefficients within the vector is indexed
     * quickly using a helper matrix.
     *  If a coefficient is chosen with column index i and row index j then 
     * position (i,j) within the matrix stores the position of the
     * coefficient within the vector of the current coefficient value.
     *  This should make searches quick however uses more memory than a 
     * method where a search is made of a vector each time to locate the
     * coefficients position.
     *  Initialize helper matrix to zero.  A zero at (i,j) indicates that
     * the atom at position (i,j) has not been chosen.
     */
    ulong nAtoms = nAtomsColumn*nAtomsRow;
    double *mIndCoefficients = new double[nAtoms];
    AllocateElements(mIndCoefficients, 0, nAtoms);


	/* Dynamic array to store dictionary atoms used in ProjMPD */
	double *mDictColumnsPicked = new double[maxNAtoms*nRows];
	double *mDictRowsPicked = new double[maxNAtoms*nColumns];
    
    /* Zero the counter passed to this function which sums up the number of iterations of ProjMP */
    projMPIter = 0;
    
    /* Begin greedy search
     * MATLAB 
     *  for it=1:Maxit2
     *      for s=1:lstep
     */
    ulong iOutside = 0; // Required for warning message
    for ( iOutside = 0; iOutside < maxIterOutside; iOutside++)
    {
		/* Variables required for the inner and outer loop */
        ulong iAtomColumn = 0;
        ulong iAtomRow = 0;
		// Used to index start of atom in dictionary
		ulong iAtomColumn1D = 0;
		ulong iAtomRow1D = 0;

        /* The norm of the residule is a termination condition for both
         * loops so declare here */
        double normResidule = 0;

        for ( ulong iMP = 0; iMP < maxIterMP; iMP++)
        {
            /* Declare variables that will only be used inside the loop here */        
            //ulong iNewAtom = k*szSpaceYX;
            double newCoefficient = 0;
            ulong iAtomColumnRow = 0;
            
            /* If the initial space has been provided 
             * MATLAB
             *  if (numat+1)<=numind
             */
            if (nChosen < nInitialIndexes)
            {
                /* Initial Space validation perform outside of the loop */
                
                /* Get the indexes
                 * MATLAB
                 *  q(1)=indx(numat+1);
                 *  q(2)=indy(numat+1);
                 */
                
                /* Leave as double and cast, routine may be called by
                 * existing routine where all MATLAB variables are 
                 * double due to retrieval using mxGetPr.
                 */
                // CHECK THIS... // CHECK USING NCHOSEN CORRECTLY
                iAtomColumn = static_cast<int>
                        (vIndDictColumns[nChosen])-1;
                iAtomRow = static_cast<int>
                        (vIndDictRows[nChosen])-1;
                iAtomColumnRow = iAtomColumn*nAtomsRow+iAtomRow;
                
                /* Calculate coefficient
                 * MATLAB
                 *  cc(q(1),q(2))=Vx(:,q(1))'*Re*Vy(:,q(2));
                 * MODIFICATION
                 *  c = Vx(:,q(1))'*Re*Vy(:,q(2));
                 * Store the value of the coefficient and perform the
                 * update later when checking if atom has already been
                 * chosen. 
                 */
                // <<--
                    /* 1D index in the 2D dictionary */
                    // mDictColumns:- nRows x nAtomsColumn
                    iAtomColumn1D = iAtomColumn*nRows;
                    // mDictRows:- nColumns x nAtomsRow
                    iAtomRow1D = iAtomRow*nColumns;
                    newCoefficient = VectorMatrixVector(
                            &mDictColumns[iAtomColumn1D],mResidule,
                            &mDictRows[iAtomColumn1D],nRows,nColumns);
                // -->>
            }else{
                /* Choose the atom that is closest in norm to the residule
                 * MATLAB
                 *  cc=(Vx'*Re*Vy);
                 *  [c1,c2]=max(abs(cc));
                 *  [max_c,b2]=max(c1); %selects the atom
                 *  q=[c2(b2) b2];
                 * MODIFICATION
                 *  c = cc(q(1),q(2));                
                 */
                ChooseAtomSPMP2D(mDictColumns, mDictRows, mResidule, nRows, 
                        nColumns,nAtomsColumn,nAtomsRow,newCoefficient, 
                        iAtomColumn,iAtomRow,iAtomColumnRow);

                /* 1D index in the 2D dictionary */
                // mDictColumns:- nRows x nAtomsColumn
                iAtomColumn1D = iAtomColumn*nRows;
                // mDictRows:- nColumns x nAtomsRow
                iAtomRow1D = iAtomRow*nColumns;

                /* Break loop if less than tol ?????
                 * MATLAB
                 *  if max_c < tol2 
                 * MODIFICATION
                 *  if abs(c) < tol2
                 *      fprintf('%s stopped, max(|<f,D>|)<= tol2=%g.\n',name,tol2); 
                 *      break; 
                 *  end
                 */ 
                if ( abs(newCoefficient) < tolCoefficient )
                {
                    #if output
                        msg("%s stopped, max(|<f,D>|)<= tol2=%g.\n",
                            name,tolCoefficient);
                    #endif 
                    break;
                }                
            }

            /* Update the coefficients vector with chosen coefficient
             * MATLAB
             *  indq1q2=0;
             *  [testq1,indq1]=ismember(q(1),Di1);  
             *  if (testq1 ==1 & q(2)==Di2(indq1)) 
             *      indq1q2=1; 
             *  end
             *  if indq1q2==0
             *      Di1=[Di1 q(1)];
             *      Di2=[Di2 q(2)];
             *      numat=numat+1; %counts the number of distinct atoms
             *  end
             *  cscra=cc(q(1),q(2)); 
             *  cp(q(1),q(2))=cp(q(1),q(2))+cscra;
             */            
            
            /* If atom has already been chosen find position of 
             * coefficient in vCoefficients.
             * If not it will be stored in the next available slot in 
             * vCoefficients, i.e. nChosen.
             */
			// -1 as positions stored are index + 1.
            long iCoefficient = mIndCoefficients[iAtomColumnRow] - 1;
            if (iCoefficient == -1) // New atom
            {
                // Store coefficient
                vCoefficients[nChosen] = newCoefficient;
                
                /* Store indexes of the coefficient in the column and row
                 * dictionaries.
                 * MATLAB
                 *  Di1=[Di1 q(1)];
                 *  Di2=[Di2 q(2)];
                 */
				// +1 as OUTPUT (MATLAB) indexes
                vIColumnAtoms[nChosen] = iAtomColumn + 1;
                vIRowAtoms[nChosen] = iAtomRow + 1;
                        
				/* Index of first element of mDictColumnsPicked */
				ulong iChosenRow = nChosen*nRows;
				/* Index of first element of mDictRowsPicked */
				ulong iChosenColumn = nChosen*nColumns;



				/* Store chosen atoms */
				CopyElements(&mDictColumns[iAtomColumn1D],
					&mDictColumnsPicked[iChosenColumn],nRows);
				CopyElements(&mDictRows[iAtomRow1D],
					&mDictRowsPicked[iChosenRow],nColumns);

                /* This atom is stored at position nChosen in 
				 * vIColumnAtoms, vIRowAtoms and vCoefficients.
				 * Store the index of this atom in mIndCoefficients
				 * Make the index = index + 1 to use unsigned long
				 */
                mIndCoefficients[iAtomColumnRow] = nChosen + 1;
                
                // One more atom has been chosen
                nChosen++;
            }else{
                /* Perfomed in condition as we don't assume vCoefficients 
                 * has been initialized to zero
                 */                
                vCoefficients[iCoefficient] = vCoefficients[iCoefficient] +
                        newCoefficient;
            }

             
            /* Update the residule
             * MATLAB
             *  h_new=Vx(:,q(1))*cscra*Vy(:,(q(2)))';
             *  Re=Re-h_new;%computes the new residual
             * CHANGED
             *  Re = Re - Vx(:,q(1))*cscra*Vy(:,(q(2)))';
             */
            /* 1D index in the 2D dictionary */
            // mDictColumns:- nRows x nAtomsColumn
            //iAtomColumn1D = iAtomColumn*nRows;
            // mDictRows:- nColumns x nAtomsRow
            //iAtomRow1D = iAtomRow*nColumns;

            Outer(mResidule, &mDictColumns[iAtomColumn1D], 
                &mDictRows[iAtomRow1D], nRows, nColumns, -newCoefficient);

            /* Calculate frobenius norm the residule
             *  Termination condition
             * MATLAB CODE
             *  nor_new=sum(sum(abs(Re).^2))*delta;
             *  nor_new=sqrt(sum(abs(Re(:).^2))); CHANGED 
             */
            normResidule = Norm(mResidule, nPixels);
            
            
            /* Terminate inner loop ??? if condition is met
             * MATLAB
             *  if (numat>=No | (nor_new < tol)) 
             *      break;
             *  end
             */
            if (( nChosen >= maxNAtoms) ||  ( normResidule < tolApprox ))
            {
                break;
            } 
        }
        
        /* Update the approximation
         * MATLAB
         *  h = f-Re; MOVED, MORE EFFICIENT FOR LSTEP > 1. Less if 
         *  abs(newCoefficient) < tolCoefficient every time.
         */
		// Initialize approximation to the image to use AddVectors
		CopyElements(mImage,mApprox,nPixels);
		// Subtract the residule from the image (mApprox
        AddVectors(mApprox,mResidule,-1,nPixels);
        
        /* REDUNDANT
         *  l=numel(Di1);
         *  for n=1:l
         *      c(n)=cp(Di1(n),Di2(n));
         *  end
         */
        
        /* If applying a projection
         * MATLAB
         *  if imp ~= 1  %if imp=1 pure MP
         */
        if (projMP2D)
        {
            /* Project the residule with ProjMP2D
             * MATLAB
             *      [h,c,Re]=ProjMP2D_mex(Re,h,Vx(:,Di1),Vy(:,Di2),c,toln,Maxp);
             */
            
            /* Returns the number of projections performed by ProjMP2D */
            ulong iterations = 0;
            
			/* 1D index in the 2D dictionary */
            ProjMP2D(mResidule,mApprox,mDictColumnsPicked,mDictRowsPicked,
                    vCoefficients,tolProjection,maxIterProj,nRows,nColumns,
                    nChosen,iterations);
            
            /* Update the number of iterations */
            projMPIter += iterations;
            
            /* REDUNDANT
             *  for n=1:l
             *      cp(Di1(n),Di2(n))=c(n);
             *  end
             */
        
            /* Recalculate residule as it may have changed in ProjMP2D
             * MATLAB             
             *  nor_new =sqrt(sum(sum(abs(Re).^2)));
             */
            normResidule = Norm(mResidule, nPixels);
        }
            
        /* Terminate outer loop approximation is suffieient
         * MATLAB
         *  if (numat>=No | (nor_new < tol)) 
         *      break;
         *  end
         */
        if (( nChosen >= maxNAtoms)   || ( normResidule < tolApprox ))
        {
            break;
        }       
        
        
        
    }


    /* # of projections per coefficient */
    //projPerCoeff = projMPIter/nChosen;
    
    /* Free dynamic memory */
    delete [] mResidule;
    mResidule = 0;
    delete [] mIndCoefficients;
    mIndCoefficients = 0;
	delete []mDictColumnsPicked;
	mDictColumnsPicked = 0;
	delete []mDictRowsPicked;
    mDictRowsPicked = 0;

   /* Print warning if the maximum iterations have been reached
    * MATLAB
    *   if (lstep ~=Max) & (it==Maxit2) 
    *       fprintf('%s Maximum number of iterations has been reached\n',name);
    *   end
    */
    #if output
        if (( maxIterOutside ~= maxIter) && (iOutside == maxIterOutside))
        {
            msg("%s Maximum number of iterations has been reached\n",name);
        }
    #endif
    
}


    


#endif





