%This script runs the HBW approximation with the DCT basis in both the pixel and the wavelet domain.
%By defualt the approximation in the Wavelet domain, to change it comment line 9 and uncomment 10
%By default the partition is of length NbxNb=8x8 (to change it change 'Nb' at line 12)
%
%-------------------------------------------------------------------------------------------------------------
%NOTE: this script is only for comparison purposes- 
%      It is very slow just because the implementation is NOT dedicated to the ortho DCT basis.
%--------------------------------------------------------------------------------------------------------------
method='HBW-DCT2D-W' %to test DCT method in the intensity domain comment this line and uncommnet next one
%method='HBW-DCT2D'  %
%
Nb=8 %change to change block size
if strcmp(method,'HBW-DCT2D-W');
Get_DCT2D_W_Inputs %to test other images change this file
else
Get_DCT2D_Inputs %to test other images change this file
end

%
[mImage, sInfo, map] = LoadImage(ImagePath); %load the image 
[mI, bitDepth]= MImage2Grey(mImage, sInfo, map);%convert it to Grey 
%
%
bw=Nb;
blockWidth=Nb;
Dx=DCos(Nb,Nb,1);%Cosine basis
Dx=NormDict(Dx);%nomralization
Dy=Dx;

s=floor(size(mI)/bw);
%
mI=mI(1:s(1)*bw,1:s(2)*bw);%resize the images to be divisible by bw
%
mI2=mI;
wlevel=5;
if strcmp(method,'HBW-DCT2D-W');
mI= waveletcdf97(mI2, wlevel);
end
MaxIntb=255;
%
[Nx,Ny]=size(mI);

dz=zeros(bw,1);

[cmI, nXBlocks, nYBlocks] = BlockImage(mI, blockWidth); %for blocking 

NBX=nXBlocks
NBY=nYBlocks

[Lx,Ly]=size(cmI{1,1});
delta=1/(Lx*Ly);


cmIa= cell(nXBlocks,nYBlocks);
%
tol=MaxIntb^2/(10^(pss/10))% tolerance error
tol3=(tol*(Nx*Ny))%tolerance normatized error (mse)
%
%
No=numel(mI);%to stop by achieved PSNR set by (pss2)
Max=50000;
Maxp=50000;
toln=1e-8;
toln2=sqrt(toln*Lx*Ly);
%
tic
 [h,Di1,Di2,c,Nat]=HBW_MP2D(cmI,Dx,Dy,tol3,No);
toc
%=====================================================================
clear mImage
mImage=cell2mat(h);%get the images from the flocks
%
if strcmp(method,'HBW-DCT2D-W');
mImage=waveletcdf97(mImage,-wlevel);
end
%
PSNR=CalcPSNR2(mI2,mImage,MaxIntb) % PSNR of the approximation
SR= numel(mI)/Nat% Sparsity ratio
Numeber_of_Atoms=Nat %numer of atoms
MSSIM=ssim(mI2, mImage)
return

