%This script reproduces the results HBW-OMP2D in Table 1 of the paper [1]
%To change the image  comment the current ImagePath and pss value in the file Get_HBW_OMP2D_Inputs.m and uncomment the ImagePath and pss value of the Image you want to approximate 
%---------------------------------------------------------------------------------------------------------
%By default the C++ MEX file   is used. To use the Matlab  version comment line 58 and uncomment line 57
%---------------------------------------------------------------------------------------------------------
%
%[1]Ref:Laura Rebollo-Neira,
%Effective sparse representation of X-Ray medical images
%http://www.nonlinear-approx.info/examples/node06.html
%
%
Get_HBW_OMP2D_Inputs
%
%
[mImage, sInfo, map] = LoadImage(ImagePath); %load the image 
[mI, bitDepth]= MImage2Grey(mImage, sInfo, map);%convert it to Grey 
%
Nb=8 %block size 
%
bw=Nb;
blockWidth=Nb;
%
get_mix_dict %input the dictionary mixed dictioanries Dx and Dy
%
s=floor(size(mI)/bw);
%
mI=mI(1:s(1)*bw,1:s(2)*bw);%resize the images to be divisible by bw
mI2=mI; %keep the pixel image
wlevel=5;
mI= waveletcdf97(mI2, wlevel);%transform to wavelet domain
%
MaxInt=max(max(mI2));
MaxIntb=255;
%
[Nx,Ny]=size(mI2);
%
dz=zeros(bw,1);
%
[cmI, nXBlocks, nYBlocks] = BlockImage(mI, blockWidth); %for blocking 
%
NBX=nXBlocks
NBY=nYBlocks
%
[Lx,Ly]=size(cmI{1,1});
delta=1/(Lx*Ly);
%
cmIa= cell(nXBlocks,nYBlocks);
%
tol=MaxInt^2/(10^(pss/10))% tolerance error
tol3=(tol*(Nx*Ny))%tolerance normatized error (mse)
%
B=cmI; %cell array with all the blocks
No=numel(mI);%to stop by achieved the PSNR set by 'pss' above
%
clear c Di1 Di2 beta c Q hbw
tic
%[hbw,Di1,Di2,beta,c,Q,Nat]=HBW_OMP2D(B,Dx,Dy,tol3,No);
[hbw,Di1,Di2,beta,c,Q,Nat]=HBW_OMP2D_Mex(B,Dx,Dy,tol3,No);
toc
%=====================================================================
clear mImage
mIc=cell2mat(hbw);%get the images from the flocks
mImage=waveletcdf97(mIc,-wlevel);%get back to the pixes domain
PSNR=CalcPSNR2(mI2,mImage,MaxIntb) % PSNR of the approximation
SR= numel(mI2)/Nat% Sparsity ratio
Nat %numer of atoms
fprintf('Method HBW-OMP2D \n');
%imshow(uint8(mImage))
clear ssim_ind
MSSIM=ssim(mI2, mImage) %
return

