%This script reproduces the OMP2D results in Table 1 of the paper [1]
%To change the image comment the current ImagePath and pss value in the file Get_OMP2D_Inputs.m and uncomment the ImagePath and pss value of the Image you want to approximate 
%---------------------------------------------------------------------------------------------------------
%By default the scripts runs the C++ MEX file  m file comment line 65 and uncomment line 64
%---------------------------------------------------------------------------------------------------------
%
%[1]Ref:Laura Rebollo-Neira,
%Effective sparse representation of X-Ray medical images
%http://www.nonlinear-approx.info/examples/node06.html
%
Get_OMP2D_Inputs  %modify this file to change the image
%
Nb=8 %change to change block size
%
%---------------------------------------------------------------------------
% 
[mImage, sInfo, map] = LoadImage(ImagePath); %load the image 
[mI, bitDepth] = MImage2Grey(mImage, sInfo, map);%convert it to Grey
%
bw=Nb;
blockWidth=bw;
%
clear  Di1 Di2 Q c cbeta h
%===input the mixed dictionary- to change it input Dx Dy.===
get_mix_dict
%===========================================================
%
s=floor(size(mI)/bw);
%
mI=mI(1:s(1)*bw,1:s(2)*bw); %rezise the images to be divisible by bw
mI2=mI;  %keep the pixel image
wlevel=5;
%
mI= waveletcdf97(mI2, wlevel);  %transform to wavelet domain
%
MaxInt=max(max(mI2));
MaxIntb=255;
%
dz=zeros(bw,1);
%
tic
[cmI, nYBlocks, nXBlocks] = BlockImage(mI, blockWidth); %for blocking 
%
[Lx,Ly]=size(cmI{1,1});
delta=1/(Lx*Ly);
NBY=nYBlocks;
NBX=nXBlocks;
%
cmIa= cell(nYBlocks,nXBlocks);
No=[];
tol=MaxIntb^2/(10^(pss/10));
tol2=sqrt(tol*(Lx*Ly));
nCoe=0;
darkb=0;
indx=[];
indy=[];
%---------------------------------------------------
q=0;
for i = 1:nYBlocks
for j = 1:nXBlocks
q=q+1;
B=cmI{i,j};
 if sum(sum(B).^2)*delta>1e-5 %if the intensity of the whole block is zero use the zero block
%[h,Di1{q},Di2{q},cbeta{q},c{q},Q]=OMP2D_m(B,Dx,Dy,tol,No);
[h,Di1{q},Di2{q},cbeta,c{q},Q,vin]=OMP2D_Mex(B,Dx,Dy,tol2^2,No,indx,indy);
if c{q}==0 darkb=darkb+1; end
cmIa{i,j}=h ; % h is the appoximation of the block
nCoe = nCoe + numel(c{q}); %count the total coefficients
else
    cmIa{i,j}=dz*dz'; %zero block 
    c{q}=0;
end
end
end 
toc
clear mImage
mIc=cell2mat(cmIa);%get the images from the flocks
mImage=waveletcdf97(mIc,-wlevel);%get back to the pixes domain
PSNR=CalcPSNR2(mI2,mImage,MaxIntb) % PSNR of the approximation
SR= numel(mI2)/nCoe % Sparsity ratio
clear ssim_ind
MSSIM=ssim(mI2, mImage)
